/*****************************************************************************/
/* Disp for WonderWitch                                                      */
/* ǥץ쥤Ϣ򰷤饹                                              */
/*****************************************************************************/

#include "dspp.h"

#include "etc.h"

int Disp_GetRollX(Disp disp) { return (disp->roll_x); }
int Disp_GetRollY(Disp disp) { return (disp->roll_y); }

/*---------------------------------------------------------------------------*/
/* ǻѤؿ                                                        */
/*---------------------------------------------------------------------------*/

static unsigned char ClearBit(unsigned char bitmap[], int number)
{
  unsigned char mask;

  mask = ((unsigned char)0x01) << (number % 8);
  bitmap[number / 8] &= ~mask;
  return (bitmap[number / 8]);
}

static unsigned char SetBit(unsigned char bitmap[], int number)
{
  unsigned char mask;

  mask = ((unsigned char)0x01) << (number % 8);
  bitmap[number / 8] |= mask;
  return (bitmap[number / 8]);
}

static int GetBit(unsigned char bitmap[], int number)
{
  unsigned char mask;

  mask = ((unsigned char)0x01) << (number % 8);
  return ((bitmap[number / 8] & mask) != 0);
}

static SpriteSetRange(unsigned char bitmap[])
{
  int i;
  int n = DISP_SPRITE_OFFSET - 1;

  for (i = DISP_SPRITE_OFFSET; i < DISP_SPRITES_NUMBER; i++) {
    if (GetBit(bitmap, i)) n = i;
  }

  sprite_set_range(DISP_SPRITE_OFFSET, n - DISP_SPRITE_OFFSET + 1);
}

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Disp Disp_Create(Disp disp)
{
  int i;
  unsigned short int bits1;
  unsigned short int bits2;

  bits1 = 0x0000;
  bits1 &= ~0x0001; /* ꡼1ɽ */
  bits1 |=  0x0002; /* ꡼2ɽ */
  bits1 |=  0x0004; /* ץ饤ɽͭ */
  bits1 &= ~0x0008; /* ץ饤ȥɥǽ̵ */
  bits1 &= ~0x0010; /* ꡼2ɥǽ̵ */
  bits1 &= ~0x0020; /* ꡼2ɥǽ̵ */
  bits1 &= ~0x0040; /* ̤ */
  bits1 &= ~0x0080; /* ̤ */
  bits1 &= ~0x0100; /* ܡ顼 */
  bits1 &= ~0x0200; /* ܡ顼 */
  bits1 &= ~0x0400; /* ܡ顼 */
  bits1 &= ~0x0800; /* ܡ顼 */
  bits1 &= ~0x1000; /* ̤ */
  bits1 &= ~0x2000; /* ̤ */
  bits1 &= ~0x4000; /* ̤ */
  bits1 &= ~0x8000; /* ̤ */

  display_control(bits1);

  /* LCD顼ѥåȤ(ñʳĴ顼ˤ) */
  bits1  = 0x0000;
  bits1 |= 0x0      ; /* LCD 顼ѥå 0 */
  bits1 |= 0x2 <<  4; /* LCD 顼ѥå 1 */
  bits1 |= 0x4 <<  8; /* LCD 顼ѥå 2 */
  bits1 |= 0x6 << 12; /* LCD 顼ѥå 3 */

  bits2  = 0x0000;
  bits2 |= 0x8      ; /* LCD 顼ѥå 4 */
  bits2 |= 0xa <<  4; /* LCD 顼ѥå 5 */
  bits2 |= 0xc <<  8; /* LCD 顼ѥå 6 */
  bits2 |= 0xf << 12; /* LCD 顼ѥå 7 */

  lcd_set_color(bits1, bits2);

  /* 饯顼ѥåȤ */
  bits1  = 0x0000;
  bits1 |= 0x0      ; /* 00 ο */
  bits1 |= 0x2 <<  4; /* 01 ο */
  bits1 |= 0x4 <<  8; /* 10 ο */
  bits1 |= 0x7 << 12; /* 11 ο */
  for (i = 0; i < 16; i++) {
    palette_set_color(i, bits1);
  }

  font_set_color(0x0003 << 0);

  for (i = 0; i < DISP_SPRITES_NUMBER; i++) {
    if (i < DISP_SPRITE_OFFSET) SetBit(disp->sprites, i);
    else ClearBit(disp->sprites, i);
  }

  for (i = 0; i < DISP_CHARACTERS_NUMBER; i++) {
    if (i < DISP_CHARACTER_OFFSET) SetBit(disp->characters, i);
    else ClearBit(disp->characters, i);
  }

  disp->roll_x = 0;
  disp->roll_y = 0;

  screen_set_scroll(SCREEN1, disp->roll_x, disp->roll_y);
  screen_set_scroll(SCREEN2, disp->roll_x, disp->roll_y);

  SpriteSetRange(disp->sprites);

  key_set_repeat(4, 0); /* ȥԡ̵ */

  return (disp);
}

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Disp Disp_Destroy(Disp disp)
{
  /* ǥץ쥤θä餳˽ */

  return (NULL);
}

/*---------------------------------------------------------------------------*/
/* Ѳǽʥץ饤ֹ                                        */
/*---------------------------------------------------------------------------*/

int Disp_GetSpriteNumber(Disp disp)
{
  int i;

  for (i = 0; i < DISP_SPRITES_NUMBER; i++) {
    if (!GetBit(disp->sprites, i)) {
      SetBit(disp->sprites, i);
      SpriteSetRange(disp->sprites);
      return (i);
    }
  }
  return (-1);
}

/*---------------------------------------------------------------------------*/
/* ץ饤ֵֹѤ                                                  */
/*---------------------------------------------------------------------------*/

int Disp_ReturnSpriteNumber(Disp disp, int number)
{
  if (!GetBit(disp->sprites, number))
    Error("Disp_ReturnSpriteNumber", "This number has already returned");
  ClearBit(disp->sprites, number);
  SpriteSetRange(disp->sprites);
  return (0);
}

/*---------------------------------------------------------------------------*/
/* Ѳǽʥ饯ֹ                                      */
/*---------------------------------------------------------------------------*/

int Disp_GetCharacterNumber(Disp disp)
{
  int i;

  for (i = 0; i < DISP_CHARACTERS_NUMBER; i++) {
    if (!GetBit(disp->characters, i)) {
      SetBit(disp->characters, i);
      return (i);
    }
  }
  return (-1);
}

/*---------------------------------------------------------------------------*/
/* 饯ֵֹѤ                                                */
/*---------------------------------------------------------------------------*/

int Disp_ReturnCharacterNumber(Disp disp, int number)
{
  if (!GetBit(disp->characters, number))
    Error("Disp_ReturnCharacterNumber", "This number has already returned");
  ClearBit(disp->characters, number);
  return (0);
}

/*---------------------------------------------------------------------------*/
/*                                                                   */
/*---------------------------------------------------------------------------*/

int Disp_GetButtonStatus(Disp disp)
{
#if 0
  return (key_hit_check_with_repeat());
#else
  return (key_hit_check());
#endif
}

/*---------------------------------------------------------------------------*/
/* ꤷɸ̤ˤäƤ                                      */
/*---------------------------------------------------------------------------*/

int Disp_PutPointAtCenterOfScreen(Disp disp, int x, int y)
{
  x = x - (DISP_DISPLAY_WIDTH  / 2);
  y = y - (DISP_DISPLAY_HEIGHT / 2);

  if (x < 0) x = 0;
  if (y < 0) y = 0;

  if (x > DISP_SCREEN_WIDTH  - DISP_DISPLAY_WIDTH)
    x = DISP_SCREEN_WIDTH  - DISP_DISPLAY_WIDTH;
  if (y > DISP_SCREEN_HEIGHT - DISP_DISPLAY_HEIGHT)
    y = DISP_SCREEN_HEIGHT - DISP_DISPLAY_HEIGHT;

  disp->roll_x = x;
  disp->roll_y = y;
  screen_set_scroll(SCREEN2, disp->roll_x, disp->roll_y);

  return (0);
}

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
